#include <bits/stdc++.h>
using namespace std;
int main(){
    ios_base::sync_with_stdio(false);cin.tie(0);cout.tie(0);
    int n;cin >> n;
    long long broj=0;
    vector<int>tackex(n);
    vector<int>tackey(n);
    for(int i=0;i<n;i++)cin >> tackex[i] >> tackey[i];
    cout << 0 << "\n";
    int x1,x2,y1,y2;
    x1=tackex[0];//min
    x2=tackex[0];//max
    y1=tackey[0];//min
    y2=tackey[0];//max
    for(int i=1;i<n;i++){
        x1=min(x1,tackex[i]);
        x2=max(x2,tackex[i]);
        y1=min(y1,tackey[i]);
        y2=max(y2,tackey[i]);
        int broj=0;
        broj=abs(x2-x1)*abs(y2-y1);
        cout << broj << "\n";
    }
    return 0;
}